// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * Voltage regulation function
 * </pre>
 *
 * Protobuf type {@code essmodule.VoltageRegulation}
 */
public final class VoltageRegulation extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.VoltageRegulation)
    VoltageRegulationOrBuilder {
private static final long serialVersionUID = 0L;
  // Use VoltageRegulation.newBuilder() to construct.
  private VoltageRegulation(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private VoltageRegulation() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new VoltageRegulation();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_VoltageRegulation_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_VoltageRegulation_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.VoltageRegulation.class, openfmb.essmodule.VoltageRegulation.Builder.class);
  }

  public static final int OVERVOLTAGEDROOP_FIELD_NUMBER = 1;
  private com.google.protobuf.FloatValue overVoltageDroop_;
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
   * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
   * upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
   * @return Whether the overVoltageDroop field is set.
   */
  @java.lang.Override
  public boolean hasOverVoltageDroop() {
    return overVoltageDroop_ != null;
  }
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
   * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
   * upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
   * @return The overVoltageDroop.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getOverVoltageDroop() {
    return overVoltageDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : overVoltageDroop_;
  }
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
   * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
   * upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getOverVoltageDroopOrBuilder() {
    return overVoltageDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : overVoltageDroop_;
  }

  public static final int UNDERVOLTAGEDROOP_FIELD_NUMBER = 2;
  private com.google.protobuf.FloatValue underVoltageDroop_;
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
   * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
   * upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
   * @return Whether the underVoltageDroop field is set.
   */
  @java.lang.Override
  public boolean hasUnderVoltageDroop() {
    return underVoltageDroop_ != null;
  }
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
   * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
   * upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
   * @return The underVoltageDroop.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getUnderVoltageDroop() {
    return underVoltageDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : underVoltageDroop_;
  }
  /**
   * <pre>
   * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
   * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
   * upper or lower dead band. The minimum droop value possible is 0.8%.
   * </pre>
   *
   * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getUnderVoltageDroopOrBuilder() {
    return underVoltageDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : underVoltageDroop_;
  }

  public static final int VOLTAGEDEADBANDMINUS_FIELD_NUMBER = 3;
  private com.google.protobuf.FloatValue voltageDeadBandMinus_;
  /**
   * <pre>
   * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
   * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
   * set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
   * @return Whether the voltageDeadBandMinus field is set.
   */
  @java.lang.Override
  public boolean hasVoltageDeadBandMinus() {
    return voltageDeadBandMinus_ != null;
  }
  /**
   * <pre>
   * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
   * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
   * set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
   * @return The voltageDeadBandMinus.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getVoltageDeadBandMinus() {
    return voltageDeadBandMinus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageDeadBandMinus_;
  }
  /**
   * <pre>
   * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
   * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
   * set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getVoltageDeadBandMinusOrBuilder() {
    return voltageDeadBandMinus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageDeadBandMinus_;
  }

  public static final int VOLTAGEDEADBANDPLUS_FIELD_NUMBER = 4;
  private com.google.protobuf.FloatValue voltageDeadBandPlus_;
  /**
   * <pre>
   * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
   * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
   * set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
   * @return Whether the voltageDeadBandPlus field is set.
   */
  @java.lang.Override
  public boolean hasVoltageDeadBandPlus() {
    return voltageDeadBandPlus_ != null;
  }
  /**
   * <pre>
   * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
   * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
   * set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
   * @return The voltageDeadBandPlus.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getVoltageDeadBandPlus() {
    return voltageDeadBandPlus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageDeadBandPlus_;
  }
  /**
   * <pre>
   * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
   * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
   * set point – dead band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getVoltageDeadBandPlusOrBuilder() {
    return voltageDeadBandPlus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageDeadBandPlus_;
  }

  public static final int VOLTAGESETPOINT_FIELD_NUMBER = 5;
  private com.google.protobuf.FloatValue voltageSetPoint_;
  /**
   * <pre>
   * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
   * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
   * band plus Lower stable band = frequency set point – band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
   * @return Whether the voltageSetPoint field is set.
   */
  @java.lang.Override
  public boolean hasVoltageSetPoint() {
    return voltageSetPoint_ != null;
  }
  /**
   * <pre>
   * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
   * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
   * band plus Lower stable band = frequency set point – band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
   * @return The voltageSetPoint.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getVoltageSetPoint() {
    return voltageSetPoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageSetPoint_;
  }
  /**
   * <pre>
   * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
   * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
   * band plus Lower stable band = frequency set point – band minus
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getVoltageSetPointOrBuilder() {
    return voltageSetPoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageSetPoint_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (overVoltageDroop_ != null) {
      output.writeMessage(1, getOverVoltageDroop());
    }
    if (underVoltageDroop_ != null) {
      output.writeMessage(2, getUnderVoltageDroop());
    }
    if (voltageDeadBandMinus_ != null) {
      output.writeMessage(3, getVoltageDeadBandMinus());
    }
    if (voltageDeadBandPlus_ != null) {
      output.writeMessage(4, getVoltageDeadBandPlus());
    }
    if (voltageSetPoint_ != null) {
      output.writeMessage(5, getVoltageSetPoint());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (overVoltageDroop_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getOverVoltageDroop());
    }
    if (underVoltageDroop_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getUnderVoltageDroop());
    }
    if (voltageDeadBandMinus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getVoltageDeadBandMinus());
    }
    if (voltageDeadBandPlus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getVoltageDeadBandPlus());
    }
    if (voltageSetPoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getVoltageSetPoint());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.VoltageRegulation)) {
      return super.equals(obj);
    }
    openfmb.essmodule.VoltageRegulation other = (openfmb.essmodule.VoltageRegulation) obj;

    if (hasOverVoltageDroop() != other.hasOverVoltageDroop()) return false;
    if (hasOverVoltageDroop()) {
      if (!getOverVoltageDroop()
          .equals(other.getOverVoltageDroop())) return false;
    }
    if (hasUnderVoltageDroop() != other.hasUnderVoltageDroop()) return false;
    if (hasUnderVoltageDroop()) {
      if (!getUnderVoltageDroop()
          .equals(other.getUnderVoltageDroop())) return false;
    }
    if (hasVoltageDeadBandMinus() != other.hasVoltageDeadBandMinus()) return false;
    if (hasVoltageDeadBandMinus()) {
      if (!getVoltageDeadBandMinus()
          .equals(other.getVoltageDeadBandMinus())) return false;
    }
    if (hasVoltageDeadBandPlus() != other.hasVoltageDeadBandPlus()) return false;
    if (hasVoltageDeadBandPlus()) {
      if (!getVoltageDeadBandPlus()
          .equals(other.getVoltageDeadBandPlus())) return false;
    }
    if (hasVoltageSetPoint() != other.hasVoltageSetPoint()) return false;
    if (hasVoltageSetPoint()) {
      if (!getVoltageSetPoint()
          .equals(other.getVoltageSetPoint())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasOverVoltageDroop()) {
      hash = (37 * hash) + OVERVOLTAGEDROOP_FIELD_NUMBER;
      hash = (53 * hash) + getOverVoltageDroop().hashCode();
    }
    if (hasUnderVoltageDroop()) {
      hash = (37 * hash) + UNDERVOLTAGEDROOP_FIELD_NUMBER;
      hash = (53 * hash) + getUnderVoltageDroop().hashCode();
    }
    if (hasVoltageDeadBandMinus()) {
      hash = (37 * hash) + VOLTAGEDEADBANDMINUS_FIELD_NUMBER;
      hash = (53 * hash) + getVoltageDeadBandMinus().hashCode();
    }
    if (hasVoltageDeadBandPlus()) {
      hash = (37 * hash) + VOLTAGEDEADBANDPLUS_FIELD_NUMBER;
      hash = (53 * hash) + getVoltageDeadBandPlus().hashCode();
    }
    if (hasVoltageSetPoint()) {
      hash = (37 * hash) + VOLTAGESETPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getVoltageSetPoint().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.VoltageRegulation parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.VoltageRegulation parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.VoltageRegulation parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.VoltageRegulation parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.VoltageRegulation parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.VoltageRegulation parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.VoltageRegulation parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.VoltageRegulation parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.VoltageRegulation parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.VoltageRegulation parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.VoltageRegulation parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.VoltageRegulation parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.VoltageRegulation prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Voltage regulation function
   * </pre>
   *
   * Protobuf type {@code essmodule.VoltageRegulation}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.VoltageRegulation)
      openfmb.essmodule.VoltageRegulationOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_VoltageRegulation_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_VoltageRegulation_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.VoltageRegulation.class, openfmb.essmodule.VoltageRegulation.Builder.class);
    }

    // Construct using openfmb.essmodule.VoltageRegulation.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      overVoltageDroop_ = null;
      if (overVoltageDroopBuilder_ != null) {
        overVoltageDroopBuilder_.dispose();
        overVoltageDroopBuilder_ = null;
      }
      underVoltageDroop_ = null;
      if (underVoltageDroopBuilder_ != null) {
        underVoltageDroopBuilder_.dispose();
        underVoltageDroopBuilder_ = null;
      }
      voltageDeadBandMinus_ = null;
      if (voltageDeadBandMinusBuilder_ != null) {
        voltageDeadBandMinusBuilder_.dispose();
        voltageDeadBandMinusBuilder_ = null;
      }
      voltageDeadBandPlus_ = null;
      if (voltageDeadBandPlusBuilder_ != null) {
        voltageDeadBandPlusBuilder_.dispose();
        voltageDeadBandPlusBuilder_ = null;
      }
      voltageSetPoint_ = null;
      if (voltageSetPointBuilder_ != null) {
        voltageSetPointBuilder_.dispose();
        voltageSetPointBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_VoltageRegulation_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.VoltageRegulation getDefaultInstanceForType() {
      return openfmb.essmodule.VoltageRegulation.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.VoltageRegulation build() {
      openfmb.essmodule.VoltageRegulation result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.VoltageRegulation buildPartial() {
      openfmb.essmodule.VoltageRegulation result = new openfmb.essmodule.VoltageRegulation(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.VoltageRegulation result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.overVoltageDroop_ = overVoltageDroopBuilder_ == null
            ? overVoltageDroop_
            : overVoltageDroopBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.underVoltageDroop_ = underVoltageDroopBuilder_ == null
            ? underVoltageDroop_
            : underVoltageDroopBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.voltageDeadBandMinus_ = voltageDeadBandMinusBuilder_ == null
            ? voltageDeadBandMinus_
            : voltageDeadBandMinusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.voltageDeadBandPlus_ = voltageDeadBandPlusBuilder_ == null
            ? voltageDeadBandPlus_
            : voltageDeadBandPlusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.voltageSetPoint_ = voltageSetPointBuilder_ == null
            ? voltageSetPoint_
            : voltageSetPointBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.VoltageRegulation) {
        return mergeFrom((openfmb.essmodule.VoltageRegulation)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.VoltageRegulation other) {
      if (other == openfmb.essmodule.VoltageRegulation.getDefaultInstance()) return this;
      if (other.hasOverVoltageDroop()) {
        mergeOverVoltageDroop(other.getOverVoltageDroop());
      }
      if (other.hasUnderVoltageDroop()) {
        mergeUnderVoltageDroop(other.getUnderVoltageDroop());
      }
      if (other.hasVoltageDeadBandMinus()) {
        mergeVoltageDeadBandMinus(other.getVoltageDeadBandMinus());
      }
      if (other.hasVoltageDeadBandPlus()) {
        mergeVoltageDeadBandPlus(other.getVoltageDeadBandPlus());
      }
      if (other.hasVoltageSetPoint()) {
        mergeVoltageSetPoint(other.getVoltageSetPoint());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getOverVoltageDroopFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getUnderVoltageDroopFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getVoltageDeadBandMinusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getVoltageDeadBandPlusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getVoltageSetPointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private com.google.protobuf.FloatValue overVoltageDroop_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> overVoltageDroopBuilder_;
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
     * @return Whether the overVoltageDroop field is set.
     */
    public boolean hasOverVoltageDroop() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
     * @return The overVoltageDroop.
     */
    public com.google.protobuf.FloatValue getOverVoltageDroop() {
      if (overVoltageDroopBuilder_ == null) {
        return overVoltageDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : overVoltageDroop_;
      } else {
        return overVoltageDroopBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
     */
    public Builder setOverVoltageDroop(com.google.protobuf.FloatValue value) {
      if (overVoltageDroopBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        overVoltageDroop_ = value;
      } else {
        overVoltageDroopBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
     */
    public Builder setOverVoltageDroop(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (overVoltageDroopBuilder_ == null) {
        overVoltageDroop_ = builderForValue.build();
      } else {
        overVoltageDroopBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
     */
    public Builder mergeOverVoltageDroop(com.google.protobuf.FloatValue value) {
      if (overVoltageDroopBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          overVoltageDroop_ != null &&
          overVoltageDroop_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getOverVoltageDroopBuilder().mergeFrom(value);
        } else {
          overVoltageDroop_ = value;
        }
      } else {
        overVoltageDroopBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
     */
    public Builder clearOverVoltageDroop() {
      bitField0_ = (bitField0_ & ~0x00000001);
      overVoltageDroop_ = null;
      if (overVoltageDroopBuilder_ != null) {
        overVoltageDroopBuilder_.dispose();
        overVoltageDroopBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
     */
    public com.google.protobuf.FloatValue.Builder getOverVoltageDroopBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getOverVoltageDroopFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getOverVoltageDroopOrBuilder() {
      if (overVoltageDroopBuilder_ != null) {
        return overVoltageDroopBuilder_.getMessageOrBuilder();
      } else {
        return overVoltageDroop_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : overVoltageDroop_;
      }
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue overVoltageDroop = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getOverVoltageDroopFieldBuilder() {
      if (overVoltageDroopBuilder_ == null) {
        overVoltageDroopBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getOverVoltageDroop(),
                getParentForChildren(),
                isClean());
        overVoltageDroop_ = null;
      }
      return overVoltageDroopBuilder_;
    }

    private com.google.protobuf.FloatValue underVoltageDroop_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> underVoltageDroopBuilder_;
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
     * @return Whether the underVoltageDroop field is set.
     */
    public boolean hasUnderVoltageDroop() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
     * @return The underVoltageDroop.
     */
    public com.google.protobuf.FloatValue getUnderVoltageDroop() {
      if (underVoltageDroopBuilder_ == null) {
        return underVoltageDroop_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : underVoltageDroop_;
      } else {
        return underVoltageDroopBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
     */
    public Builder setUnderVoltageDroop(com.google.protobuf.FloatValue value) {
      if (underVoltageDroopBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        underVoltageDroop_ = value;
      } else {
        underVoltageDroopBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
     */
    public Builder setUnderVoltageDroop(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (underVoltageDroopBuilder_ == null) {
        underVoltageDroop_ = builderForValue.build();
      } else {
        underVoltageDroopBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
     */
    public Builder mergeUnderVoltageDroop(com.google.protobuf.FloatValue value) {
      if (underVoltageDroopBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          underVoltageDroop_ != null &&
          underVoltageDroop_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getUnderVoltageDroopBuilder().mergeFrom(value);
        } else {
          underVoltageDroop_ = value;
        }
      } else {
        underVoltageDroopBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
     */
    public Builder clearUnderVoltageDroop() {
      bitField0_ = (bitField0_ & ~0x00000002);
      underVoltageDroop_ = null;
      if (underVoltageDroopBuilder_ != null) {
        underVoltageDroopBuilder_.dispose();
        underVoltageDroopBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
     */
    public com.google.protobuf.FloatValue.Builder getUnderVoltageDroopBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getUnderVoltageDroopFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getUnderVoltageDroopOrBuilder() {
      if (underVoltageDroopBuilder_ != null) {
        return underVoltageDroopBuilder_.getMessageOrBuilder();
      } else {
        return underVoltageDroop_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : underVoltageDroop_;
      }
    }
    /**
     * <pre>
     * uint/0.1%  The droops define the reaction of the PCS to under/over voltage events. A droop of 1%
     * means that the PCS will output 100% power if the voltage is 1% of the nominal voltage away from the
     * upper or lower dead band. The minimum droop value possible is 0.8%.
     * </pre>
     *
     * <code>.google.protobuf.FloatValue underVoltageDroop = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getUnderVoltageDroopFieldBuilder() {
      if (underVoltageDroopBuilder_ == null) {
        underVoltageDroopBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getUnderVoltageDroop(),
                getParentForChildren(),
                isClean());
        underVoltageDroop_ = null;
      }
      return underVoltageDroopBuilder_;
    }

    private com.google.protobuf.FloatValue voltageDeadBandMinus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> voltageDeadBandMinusBuilder_;
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
     * @return Whether the voltageDeadBandMinus field is set.
     */
    public boolean hasVoltageDeadBandMinus() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
     * @return The voltageDeadBandMinus.
     */
    public com.google.protobuf.FloatValue getVoltageDeadBandMinus() {
      if (voltageDeadBandMinusBuilder_ == null) {
        return voltageDeadBandMinus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageDeadBandMinus_;
      } else {
        return voltageDeadBandMinusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
     */
    public Builder setVoltageDeadBandMinus(com.google.protobuf.FloatValue value) {
      if (voltageDeadBandMinusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        voltageDeadBandMinus_ = value;
      } else {
        voltageDeadBandMinusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
     */
    public Builder setVoltageDeadBandMinus(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (voltageDeadBandMinusBuilder_ == null) {
        voltageDeadBandMinus_ = builderForValue.build();
      } else {
        voltageDeadBandMinusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
     */
    public Builder mergeVoltageDeadBandMinus(com.google.protobuf.FloatValue value) {
      if (voltageDeadBandMinusBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          voltageDeadBandMinus_ != null &&
          voltageDeadBandMinus_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getVoltageDeadBandMinusBuilder().mergeFrom(value);
        } else {
          voltageDeadBandMinus_ = value;
        }
      } else {
        voltageDeadBandMinusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
     */
    public Builder clearVoltageDeadBandMinus() {
      bitField0_ = (bitField0_ & ~0x00000004);
      voltageDeadBandMinus_ = null;
      if (voltageDeadBandMinusBuilder_ != null) {
        voltageDeadBandMinusBuilder_.dispose();
        voltageDeadBandMinusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
     */
    public com.google.protobuf.FloatValue.Builder getVoltageDeadBandMinusBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getVoltageDeadBandMinusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getVoltageDeadBandMinusOrBuilder() {
      if (voltageDeadBandMinusBuilder_ != null) {
        return voltageDeadBandMinusBuilder_.getMessageOrBuilder();
      } else {
        return voltageDeadBandMinus_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : voltageDeadBandMinus_;
      }
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandMinus = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getVoltageDeadBandMinusFieldBuilder() {
      if (voltageDeadBandMinusBuilder_ == null) {
        voltageDeadBandMinusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getVoltageDeadBandMinus(),
                getParentForChildren(),
                isClean());
        voltageDeadBandMinus_ = null;
      }
      return voltageDeadBandMinusBuilder_;
    }

    private com.google.protobuf.FloatValue voltageDeadBandPlus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> voltageDeadBandPlusBuilder_;
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
     * @return Whether the voltageDeadBandPlus field is set.
     */
    public boolean hasVoltageDeadBandPlus() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
     * @return The voltageDeadBandPlus.
     */
    public com.google.protobuf.FloatValue getVoltageDeadBandPlus() {
      if (voltageDeadBandPlusBuilder_ == null) {
        return voltageDeadBandPlus_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageDeadBandPlus_;
      } else {
        return voltageDeadBandPlusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
     */
    public Builder setVoltageDeadBandPlus(com.google.protobuf.FloatValue value) {
      if (voltageDeadBandPlusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        voltageDeadBandPlus_ = value;
      } else {
        voltageDeadBandPlusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
     */
    public Builder setVoltageDeadBandPlus(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (voltageDeadBandPlusBuilder_ == null) {
        voltageDeadBandPlus_ = builderForValue.build();
      } else {
        voltageDeadBandPlusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
     */
    public Builder mergeVoltageDeadBandPlus(com.google.protobuf.FloatValue value) {
      if (voltageDeadBandPlusBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          voltageDeadBandPlus_ != null &&
          voltageDeadBandPlus_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getVoltageDeadBandPlusBuilder().mergeFrom(value);
        } else {
          voltageDeadBandPlus_ = value;
        }
      } else {
        voltageDeadBandPlusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
     */
    public Builder clearVoltageDeadBandPlus() {
      bitField0_ = (bitField0_ & ~0x00000008);
      voltageDeadBandPlus_ = null;
      if (voltageDeadBandPlusBuilder_ != null) {
        voltageDeadBandPlusBuilder_.dispose();
        voltageDeadBandPlusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
     */
    public com.google.protobuf.FloatValue.Builder getVoltageDeadBandPlusBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getVoltageDeadBandPlusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getVoltageDeadBandPlusOrBuilder() {
      if (voltageDeadBandPlusBuilder_ != null) {
        return voltageDeadBandPlusBuilder_.getMessageOrBuilder();
      } else {
        return voltageDeadBandPlus_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : voltageDeadBandPlus_;
      }
    }
    /**
     * <pre>
     * uint/0.1V  Voltage regulation is performed when the grid voltage goes beyond the dead bands. The
     * dead bands are defined as follows: Upper DB = voltage set point + dead band plus Lower DB = voltage
     * set point – dead band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageDeadBandPlus = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getVoltageDeadBandPlusFieldBuilder() {
      if (voltageDeadBandPlusBuilder_ == null) {
        voltageDeadBandPlusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getVoltageDeadBandPlus(),
                getParentForChildren(),
                isClean());
        voltageDeadBandPlus_ = null;
      }
      return voltageDeadBandPlusBuilder_;
    }

    private com.google.protobuf.FloatValue voltageSetPoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> voltageSetPointBuilder_;
    /**
     * <pre>
     * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
     * @return Whether the voltageSetPoint field is set.
     */
    public boolean hasVoltageSetPoint() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
     * @return The voltageSetPoint.
     */
    public com.google.protobuf.FloatValue getVoltageSetPoint() {
      if (voltageSetPointBuilder_ == null) {
        return voltageSetPoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageSetPoint_;
      } else {
        return voltageSetPointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
     */
    public Builder setVoltageSetPoint(com.google.protobuf.FloatValue value) {
      if (voltageSetPointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        voltageSetPoint_ = value;
      } else {
        voltageSetPointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
     */
    public Builder setVoltageSetPoint(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (voltageSetPointBuilder_ == null) {
        voltageSetPoint_ = builderForValue.build();
      } else {
        voltageSetPointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
     */
    public Builder mergeVoltageSetPoint(com.google.protobuf.FloatValue value) {
      if (voltageSetPointBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          voltageSetPoint_ != null &&
          voltageSetPoint_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getVoltageSetPointBuilder().mergeFrom(value);
        } else {
          voltageSetPoint_ = value;
        }
      } else {
        voltageSetPointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
     */
    public Builder clearVoltageSetPoint() {
      bitField0_ = (bitField0_ & ~0x00000010);
      voltageSetPoint_ = null;
      if (voltageSetPointBuilder_ != null) {
        voltageSetPointBuilder_.dispose();
        voltageSetPointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
     */
    public com.google.protobuf.FloatValue.Builder getVoltageSetPointBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getVoltageSetPointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getVoltageSetPointOrBuilder() {
      if (voltageSetPointBuilder_ != null) {
        return voltageSetPointBuilder_.getMessageOrBuilder();
      } else {
        return voltageSetPoint_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : voltageSetPoint_;
      }
    }
    /**
     * <pre>
     * uint/0.1V  Other modes of operation, such as peak shaving, smoothing or SOC management may
     * operate if the grid frequency is within the stable band. Upper stable band = frequency set point +
     * band plus Lower stable band = frequency set point – band minus
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetPoint = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getVoltageSetPointFieldBuilder() {
      if (voltageSetPointBuilder_ == null) {
        voltageSetPointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getVoltageSetPoint(),
                getParentForChildren(),
                isClean());
        voltageSetPoint_ = null;
      }
      return voltageSetPointBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.VoltageRegulation)
  }

  // @@protoc_insertion_point(class_scope:essmodule.VoltageRegulation)
  private static final openfmb.essmodule.VoltageRegulation DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.VoltageRegulation();
  }

  public static openfmb.essmodule.VoltageRegulation getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<VoltageRegulation>
      PARSER = new com.google.protobuf.AbstractParser<VoltageRegulation>() {
    @java.lang.Override
    public VoltageRegulation parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<VoltageRegulation> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<VoltageRegulation> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.VoltageRegulation getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

